#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "Opts.h"

/* Returns an initialized opts data type. */
Opts* newOpts(int argv, char **argc) {
  Opts  *opts;
  int   arg;
  
  /* create opts */
  opts = malloc(sizeof(Opts));

  /* set defaults */
  opts->coloring      = morphgeno;
  opts->pixelscale    = 2;
  strcpy(opts->filename, "cnid");
  opts->size          = 100;
  opts->sizesq        = 100 * 100;
  opts->steps         = 1;
  opts->init_state    = 1;    /* don't change, use -r (see below) */
  opts->init_num      = 25;
  opts->p_death       = 0.03;  //0.03
  opts->p_fuck_base   = 0.3;   //0.3
  opts->p_fuck_mat    = 0.005; //0.005
  opts->p_fight_su    = 0.53;  //0.53
  opts->p_fight_ssuu  = 0.5;   //0.5
  opts->p_mut_morph   = 0.001; //0.001
  opts->p_mut_geno    = 0.00; //0.001
  
  /* read arguments and set options */
  for (arg = 1; arg < argv; arg++) {
    if ( argc[arg][0] == '-' )
      switch (argc[arg][1]) {
        case 'c':
          opts->init_num = atoi(argc[++arg]);
          break;
        case 'h':
          printOptsUsage(argc[0]);
          break;
        case 'i':
          opts->steps  = atoi(argc[++arg]);
          break;
        case 'o':
          strcpy(opts->filename, argc[++arg]);
          break;
        case 'p':
          opts->pixelscale = atoi(argc[++arg]);
          break;
        case 'r':
          opts->init_state = 0;
          break;
        case 's':
          opts->size   = atoi(argc[++arg]);
          opts->sizesq = opts->size * opts->size;
          break;
        default:
          printOptsUsage(argc[0]);
          break;
      }
  }
  return opts;
}


void printOptsUsage(char *name) {
  printf("\nUSAGE:\n");
  printf("\t%s [-i iter] [-s size] [-c cels] [-r] [-o name] [-p pixs]\n", name);
  printf("\nARGUMENTS:\n");
  printf("\titer: iterations to run\n");
  printf("\tsize: length of square lattice\n");
  printf("\tcels: number of initial random cells\n");
  printf("\t  -r: turns on random cell placement\n");
  printf("\toutp: base filename\n");
  printf("\tpixs: pixel scale\n");
  printf("\n");
  exit(1);
}

